/*
 * Copyright 2012-2018 Alexander Baumgartner
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package at.jku.risc.stout.tgau;

import java.io.Reader;
import java.io.StringReader;

import at.jku.risc.stout.tgau.algo.AntiUnify;
import at.jku.risc.stout.tgau.algo.AntiUnifySystem;
import at.jku.risc.stout.tgau.algo.DebugLevel;
import at.jku.risc.stout.tgau.algo.RigidityFncSubsequence;
import at.jku.risc.stout.tgau.data.InputParser;
import at.jku.risc.stout.tgau.data.NodeFactory;
import at.jku.risc.stout.tgau.data.TermGraph;

public class TestExample {
	public static void main(String[] args) {
		try {
			Reader in1 = new StringReader("x=f(x,y), y=f(x,y)");
			Reader in2 = new StringReader("y=f(x,y), x=f(x,y)");
			NodeFactory nf = new NodeFactory();
			// EXPERIMENTAL COMMUTATIVE RULES:
			// nf.setCommutative("f");
			// AntiUnifySystem.ENABLE_COMMUTATIVE_RULES = true;
			AntiUnifySystem.ENABLE_SPLIT_RULE = true;
			TermGraph tg1 = new InputParser(nf).parseTermGraph(in1, AntiUnifySystem.ENABLE_COMMUTATIVE_RULES);
			TermGraph tg2 = new InputParser(nf).parseTermGraph(in2, AntiUnifySystem.ENABLE_COMMUTATIVE_RULES);
			RigidityFncSubsequence r = new RigidityFncSubsequence();
			// Optional: Set minimum alignment length:
			// r.setMinLen(3);
			AntiUnify rau = new AntiUnify(r, r, tg1, tg2, nf);
			rau.antiUnify(true, true, DebugLevel.RESULT, System.out);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
