/*
 * Copyright 2012-2018 Alexander Baumgartner
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package at.jku.risc.stout.tgau;

import java.io.StringReader;

import at.jku.risc.stout.tgau.data.InputParser;
import at.jku.risc.stout.tgau.data.NodeFactory;
import at.jku.risc.stout.tgau.data.TermGraph;
import at.jku.risc.stout.tgau.data.atom.FunctionApplication;
import at.jku.risc.stout.tgau.data.atom.TermVar;

public class TestParser {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		testParser("x=f(x,y),z=f(x,U),U=U1, y=g {{v,z,x,U,x,z}},v=a");
	}

	public static void testParser(String in) {
		try {
			NodeFactory nf = new NodeFactory();
			TermGraph g = new InputParser(nf).parseTermGraph(new StringReader(in), true);
			System.out.println(g);
			System.out.println(g.top());
			System.out.println(g.top(((FunctionApplication) g.get(nf.createTermVar("y"))).getArgs()));
			System.out.println(g.copyRootAndTrim((TermVar) nf.createTermVar("v")));
			System.out.println(nf.varCnt);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
