/*
 * Copyright 2012-2018 Alexander Baumgartner
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package at.jku.risc.stout.tgau.util;

import java.util.Arrays;

/**
 * Tiny implementation of a dynamic sized list of int values.
 * 
 * @author Alexander Baumgartner
 */
public class IntList {
	public int[] ints = new int[8];
	public int size = 0;

	public void add(int x) {
		if (size == ints.length)
			ints = Arrays.copyOf(ints, size + (size >> 1));
		ints[size++] = x;
	}

	public void remove(int idx) {
		int numMoved = --size - idx;
		if (numMoved > 0)
			System.arraycopy(ints, idx + 1, ints, idx, numMoved);
	}
}